/*
 * API documentation
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0.0-20181108155220-20181108155343
 * Contact: api.move@axa-assistance.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.insurance.bn.starter.model;

import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import org.threeten.bp.LocalDate;

import java.math.BigDecimal;
import java.util.Objects;

/**
 * List of information linked to a delayed trip incident
 */
@ApiModel(description = "List of information linked to a delayed trip incident")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2018-12-19T23:23:06.995+01:00")
public class DelayedTripClaimInformation {
  @SerializedName("Name_of_requestor")
  private String nameOfRequestor = null;

  @SerializedName("Relationship_to_cardholder")
  private String relationshipToCardholder = null;

  @SerializedName("Other_relationship_to_cardholder")
  private String otherRelationshipToCardholder = null;

  @SerializedName("Sex")
  private String sex = null;

  @SerializedName("Date_of_Birth")
  private LocalDate dateOfBirth = null;

  @SerializedName("Do_you_have_other_insurance_covering")
  private String doYouHaveOtherInsuranceCovering = null;

  @SerializedName("Reimbursed_for_any_portion_of_the_cause")
  private BigDecimal reimbursedForAnyPortionOfTheCause = null;

  @SerializedName("Amount_Reimbursed")
  private BigDecimal amountReimbursed = null;

  @SerializedName("Total_amount_claimed")
  private BigDecimal totalAmountClaimed = null;

  @SerializedName("Start_trip_date")
  private LocalDate startTripDate = null;

  @SerializedName("End_trip_date")
  private LocalDate endTripDate = null;

  @SerializedName("Date_of_delay")
  private LocalDate dateOfDelay = null;

  @SerializedName("Name_tour_operator_travel_agency")
  private String nameTourOperatorTravelAgency = null;

  @SerializedName("Address_tour_operator_travel_agency")
  private String addressTourOperatorTravelAgency = null;

  @SerializedName("Phone_tour_operator_travel_agency")
  private String phoneTourOperatorTravelAgency = null;

  @SerializedName("Briefly_describe_the_causes_that_led")
  private String brieflyDescribeTheCausesThatLed = null;

  @SerializedName("CurrencyIsoCode")
  private String currencyIsoCode = null;

  @SerializedName("TraveldelayInfo")
  private TraveldelayInfo traveldelayInfo = null;

  public DelayedTripClaimInformation nameOfRequestor(String nameOfRequestor) {
    this.nameOfRequestor = nameOfRequestor;
    return this;
  }

   /**
   * Get nameOfRequestor
   * @return nameOfRequestor
  **/
  @ApiModelProperty(example = "test", value = "")
  public String getNameOfRequestor() {
    return nameOfRequestor;
  }

  public void setNameOfRequestor(String nameOfRequestor) {
    this.nameOfRequestor = nameOfRequestor;
  }

  public DelayedTripClaimInformation relationshipToCardholder(String relationshipToCardholder) {
    this.relationshipToCardholder = relationshipToCardholder;
    return this;
  }

   /**
   * Get relationshipToCardholder
   * @return relationshipToCardholder
  **/
  @ApiModelProperty(example = "I'm the cardholder", value = "")
  public String getRelationshipToCardholder() {
    return relationshipToCardholder;
  }

  public void setRelationshipToCardholder(String relationshipToCardholder) {
    this.relationshipToCardholder = relationshipToCardholder;
  }

  public DelayedTripClaimInformation otherRelationshipToCardholder(String otherRelationshipToCardholder) {
    this.otherRelationshipToCardholder = otherRelationshipToCardholder;
    return this;
  }

   /**
   * Get otherRelationshipToCardholder
   * @return otherRelationshipToCardholder
  **/
  @ApiModelProperty(example = "testOther", value = "")
  public String getOtherRelationshipToCardholder() {
    return otherRelationshipToCardholder;
  }

  public void setOtherRelationshipToCardholder(String otherRelationshipToCardholder) {
    this.otherRelationshipToCardholder = otherRelationshipToCardholder;
  }

  public DelayedTripClaimInformation sex(String sex) {
    this.sex = sex;
    return this;
  }

   /**
   * Get sex
   * @return sex
  **/
  @ApiModelProperty(example = "Male", value = "")
  public String getSex() {
    return sex;
  }

  public void setSex(String sex) {
    this.sex = sex;
  }

  public DelayedTripClaimInformation dateOfBirth(LocalDate dateOfBirth) {
    this.dateOfBirth = dateOfBirth;
    return this;
  }

   /**
   * Get dateOfBirth
   * @return dateOfBirth
  **/
  @ApiModelProperty(example = "1988-03-12", value = "")
  public LocalDate getDateOfBirth() {
    return dateOfBirth;
  }

  public void setDateOfBirth(LocalDate dateOfBirth) {
    this.dateOfBirth = dateOfBirth;
  }

  public DelayedTripClaimInformation doYouHaveOtherInsuranceCovering(String doYouHaveOtherInsuranceCovering) {
    this.doYouHaveOtherInsuranceCovering = doYouHaveOtherInsuranceCovering;
    return this;
  }

   /**
   * Get doYouHaveOtherInsuranceCovering
   * @return doYouHaveOtherInsuranceCovering
  **/
  @ApiModelProperty(example = "NO", value = "")
  public String getDoYouHaveOtherInsuranceCovering() {
    return doYouHaveOtherInsuranceCovering;
  }

  public void setDoYouHaveOtherInsuranceCovering(String doYouHaveOtherInsuranceCovering) {
    this.doYouHaveOtherInsuranceCovering = doYouHaveOtherInsuranceCovering;
  }

  public DelayedTripClaimInformation reimbursedForAnyPortionOfTheCause(BigDecimal reimbursedForAnyPortionOfTheCause) {
    this.reimbursedForAnyPortionOfTheCause = reimbursedForAnyPortionOfTheCause;
    return this;
  }

   /**
   * Get reimbursedForAnyPortionOfTheCause
   * @return reimbursedForAnyPortionOfTheCause
  **/
  @ApiModelProperty(example = "5000.0", value = "")
  public BigDecimal getReimbursedForAnyPortionOfTheCause() {
    return reimbursedForAnyPortionOfTheCause;
  }

  public void setReimbursedForAnyPortionOfTheCause(BigDecimal reimbursedForAnyPortionOfTheCause) {
    this.reimbursedForAnyPortionOfTheCause = reimbursedForAnyPortionOfTheCause;
  }

  public DelayedTripClaimInformation amountReimbursed(BigDecimal amountReimbursed) {
    this.amountReimbursed = amountReimbursed;
    return this;
  }

   /**
   * Get amountReimbursed
   * @return amountReimbursed
  **/
  @ApiModelProperty(example = "500.0", value = "")
  public BigDecimal getAmountReimbursed() {
    return amountReimbursed;
  }

  public void setAmountReimbursed(BigDecimal amountReimbursed) {
    this.amountReimbursed = amountReimbursed;
  }

  public DelayedTripClaimInformation totalAmountClaimed(BigDecimal totalAmountClaimed) {
    this.totalAmountClaimed = totalAmountClaimed;
    return this;
  }

   /**
   * Get totalAmountClaimed
   * @return totalAmountClaimed
  **/
  @ApiModelProperty(example = "500.0", value = "")
  public BigDecimal getTotalAmountClaimed() {
    return totalAmountClaimed;
  }

  public void setTotalAmountClaimed(BigDecimal totalAmountClaimed) {
    this.totalAmountClaimed = totalAmountClaimed;
  }

  public DelayedTripClaimInformation startTripDate(LocalDate startTripDate) {
    this.startTripDate = startTripDate;
    return this;
  }

   /**
   * Get startTripDate
   * @return startTripDate
  **/
  @ApiModelProperty(example = "2017-05-12", value = "")
  public LocalDate getStartTripDate() {
    return startTripDate;
  }

  public void setStartTripDate(LocalDate startTripDate) {
    this.startTripDate = startTripDate;
  }

  public DelayedTripClaimInformation endTripDate(LocalDate endTripDate) {
    this.endTripDate = endTripDate;
    return this;
  }

   /**
   * Get endTripDate
   * @return endTripDate
  **/
  @ApiModelProperty(example = "2017-05-12", value = "")
  public LocalDate getEndTripDate() {
    return endTripDate;
  }

  public void setEndTripDate(LocalDate endTripDate) {
    this.endTripDate = endTripDate;
  }

  public DelayedTripClaimInformation dateOfDelay(LocalDate dateOfDelay) {
    this.dateOfDelay = dateOfDelay;
    return this;
  }

   /**
   * Get dateOfDelay
   * @return dateOfDelay
  **/
  @ApiModelProperty(example = "2017-05-12", value = "")
  public LocalDate getDateOfDelay() {
    return dateOfDelay;
  }

  public void setDateOfDelay(LocalDate dateOfDelay) {
    this.dateOfDelay = dateOfDelay;
  }

  public DelayedTripClaimInformation nameTourOperatorTravelAgency(String nameTourOperatorTravelAgency) {
    this.nameTourOperatorTravelAgency = nameTourOperatorTravelAgency;
    return this;
  }

   /**
   * Get nameTourOperatorTravelAgency
   * @return nameTourOperatorTravelAgency
  **/
  @ApiModelProperty(example = "test", value = "")
  public String getNameTourOperatorTravelAgency() {
    return nameTourOperatorTravelAgency;
  }

  public void setNameTourOperatorTravelAgency(String nameTourOperatorTravelAgency) {
    this.nameTourOperatorTravelAgency = nameTourOperatorTravelAgency;
  }

  public DelayedTripClaimInformation addressTourOperatorTravelAgency(String addressTourOperatorTravelAgency) {
    this.addressTourOperatorTravelAgency = addressTourOperatorTravelAgency;
    return this;
  }

   /**
   * Get addressTourOperatorTravelAgency
   * @return addressTourOperatorTravelAgency
  **/
  @ApiModelProperty(example = "testAddress", value = "")
  public String getAddressTourOperatorTravelAgency() {
    return addressTourOperatorTravelAgency;
  }

  public void setAddressTourOperatorTravelAgency(String addressTourOperatorTravelAgency) {
    this.addressTourOperatorTravelAgency = addressTourOperatorTravelAgency;
  }

  public DelayedTripClaimInformation phoneTourOperatorTravelAgency(String phoneTourOperatorTravelAgency) {
    this.phoneTourOperatorTravelAgency = phoneTourOperatorTravelAgency;
    return this;
  }

   /**
   * Get phoneTourOperatorTravelAgency
   * @return phoneTourOperatorTravelAgency
  **/
  @ApiModelProperty(example = "9010123658", value = "")
  public String getPhoneTourOperatorTravelAgency() {
    return phoneTourOperatorTravelAgency;
  }

  public void setPhoneTourOperatorTravelAgency(String phoneTourOperatorTravelAgency) {
    this.phoneTourOperatorTravelAgency = phoneTourOperatorTravelAgency;
  }

  public DelayedTripClaimInformation brieflyDescribeTheCausesThatLed(String brieflyDescribeTheCausesThatLed) {
    this.brieflyDescribeTheCausesThatLed = brieflyDescribeTheCausesThatLed;
    return this;
  }

   /**
   * Get brieflyDescribeTheCausesThatLed
   * @return brieflyDescribeTheCausesThatLed
  **/
  @ApiModelProperty(example = "test", value = "")
  public String getBrieflyDescribeTheCausesThatLed() {
    return brieflyDescribeTheCausesThatLed;
  }

  public void setBrieflyDescribeTheCausesThatLed(String brieflyDescribeTheCausesThatLed) {
    this.brieflyDescribeTheCausesThatLed = brieflyDescribeTheCausesThatLed;
  }

  public DelayedTripClaimInformation currencyIsoCode(String currencyIsoCode) {
    this.currencyIsoCode = currencyIsoCode;
    return this;
  }

   /**
   * Get currencyIsoCode
   * @return currencyIsoCode
  **/
  @ApiModelProperty(example = "USD", value = "")
  public String getCurrencyIsoCode() {
    return currencyIsoCode;
  }

  public void setCurrencyIsoCode(String currencyIsoCode) {
    this.currencyIsoCode = currencyIsoCode;
  }

  public DelayedTripClaimInformation traveldelayInfo(TraveldelayInfo traveldelayInfo) {
    this.traveldelayInfo = traveldelayInfo;
    return this;
  }

   /**
   * Get traveldelayInfo
   * @return traveldelayInfo
  **/
  @ApiModelProperty(value = "")
  public TraveldelayInfo getTraveldelayInfo() {
    return traveldelayInfo;
  }

  public void setTraveldelayInfo(TraveldelayInfo traveldelayInfo) {
    this.traveldelayInfo = traveldelayInfo;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    DelayedTripClaimInformation delayedTripClaimInformation = (DelayedTripClaimInformation) o;
    return Objects.equals(this.nameOfRequestor, delayedTripClaimInformation.nameOfRequestor) &&
        Objects.equals(this.relationshipToCardholder, delayedTripClaimInformation.relationshipToCardholder) &&
        Objects.equals(this.otherRelationshipToCardholder, delayedTripClaimInformation.otherRelationshipToCardholder) &&
        Objects.equals(this.sex, delayedTripClaimInformation.sex) &&
        Objects.equals(this.dateOfBirth, delayedTripClaimInformation.dateOfBirth) &&
        Objects.equals(this.doYouHaveOtherInsuranceCovering, delayedTripClaimInformation.doYouHaveOtherInsuranceCovering) &&
        Objects.equals(this.reimbursedForAnyPortionOfTheCause, delayedTripClaimInformation.reimbursedForAnyPortionOfTheCause) &&
        Objects.equals(this.amountReimbursed, delayedTripClaimInformation.amountReimbursed) &&
        Objects.equals(this.totalAmountClaimed, delayedTripClaimInformation.totalAmountClaimed) &&
        Objects.equals(this.startTripDate, delayedTripClaimInformation.startTripDate) &&
        Objects.equals(this.endTripDate, delayedTripClaimInformation.endTripDate) &&
        Objects.equals(this.dateOfDelay, delayedTripClaimInformation.dateOfDelay) &&
        Objects.equals(this.nameTourOperatorTravelAgency, delayedTripClaimInformation.nameTourOperatorTravelAgency) &&
        Objects.equals(this.addressTourOperatorTravelAgency, delayedTripClaimInformation.addressTourOperatorTravelAgency) &&
        Objects.equals(this.phoneTourOperatorTravelAgency, delayedTripClaimInformation.phoneTourOperatorTravelAgency) &&
        Objects.equals(this.brieflyDescribeTheCausesThatLed, delayedTripClaimInformation.brieflyDescribeTheCausesThatLed) &&
        Objects.equals(this.currencyIsoCode, delayedTripClaimInformation.currencyIsoCode) &&
        Objects.equals(this.traveldelayInfo, delayedTripClaimInformation.traveldelayInfo);
  }

  @Override
  public int hashCode() {
    return Objects.hash(nameOfRequestor, relationshipToCardholder, otherRelationshipToCardholder, sex, dateOfBirth, doYouHaveOtherInsuranceCovering, reimbursedForAnyPortionOfTheCause, amountReimbursed, totalAmountClaimed, startTripDate, endTripDate, dateOfDelay, nameTourOperatorTravelAgency, addressTourOperatorTravelAgency, phoneTourOperatorTravelAgency, brieflyDescribeTheCausesThatLed, currencyIsoCode, traveldelayInfo);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class DelayedTripClaimInformation {\n");
    
    sb.append("    nameOfRequestor: ").append(toIndentedString(nameOfRequestor)).append("\n");
    sb.append("    relationshipToCardholder: ").append(toIndentedString(relationshipToCardholder)).append("\n");
    sb.append("    otherRelationshipToCardholder: ").append(toIndentedString(otherRelationshipToCardholder)).append("\n");
    sb.append("    sex: ").append(toIndentedString(sex)).append("\n");
    sb.append("    dateOfBirth: ").append(toIndentedString(dateOfBirth)).append("\n");
    sb.append("    doYouHaveOtherInsuranceCovering: ").append(toIndentedString(doYouHaveOtherInsuranceCovering)).append("\n");
    sb.append("    reimbursedForAnyPortionOfTheCause: ").append(toIndentedString(reimbursedForAnyPortionOfTheCause)).append("\n");
    sb.append("    amountReimbursed: ").append(toIndentedString(amountReimbursed)).append("\n");
    sb.append("    totalAmountClaimed: ").append(toIndentedString(totalAmountClaimed)).append("\n");
    sb.append("    startTripDate: ").append(toIndentedString(startTripDate)).append("\n");
    sb.append("    endTripDate: ").append(toIndentedString(endTripDate)).append("\n");
    sb.append("    dateOfDelay: ").append(toIndentedString(dateOfDelay)).append("\n");
    sb.append("    nameTourOperatorTravelAgency: ").append(toIndentedString(nameTourOperatorTravelAgency)).append("\n");
    sb.append("    addressTourOperatorTravelAgency: ").append(toIndentedString(addressTourOperatorTravelAgency)).append("\n");
    sb.append("    phoneTourOperatorTravelAgency: ").append(toIndentedString(phoneTourOperatorTravelAgency)).append("\n");
    sb.append("    brieflyDescribeTheCausesThatLed: ").append(toIndentedString(brieflyDescribeTheCausesThatLed)).append("\n");
    sb.append("    currencyIsoCode: ").append(toIndentedString(currencyIsoCode)).append("\n");
    sb.append("    traveldelayInfo: ").append(toIndentedString(traveldelayInfo)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

